#include "navigatormodel.h"

#include <QPainter>

using namespace QPunchCard;
using namespace Navigator;

Model::Model(Dock* parent) : QAbstractListModel(parent), navigator(parent) {
	card_widget = new CardWidget();

	card_widget->setQuality( CardWidget::ThumbnailQuality );
	setIconSizeByWidth(73);
}

Model::~Model() {
	// cleanup (can't use QObject tree since this is not a QWidget... stupid)
	delete card_widget;
}

void Model::setIconSizeByWidth(int width) {
	icon_size = QSize(width, qRound( ((double)width / 7375) * 3250 ) );
	card_widget->setGeometry( QRect(QPoint(), icon_size) );
}

void Model::setIconSizeByHeight(int height) {
	icon_size = QSize( qRound( ((double)height / 3250) * 7375 ), height);
	card_widget->setGeometry( QRect(QPoint(), icon_size) );
}

void Model::setDeck(bool) {
	// eigentlich macht diese methode nix mehr, weil main jetzt
	// direkt im dock gespeichert ist und man sich als das
	// deck vom dock holt.

	// weils sonst gerne abstuerzt:
	reset();

	//if(!main) return; // das waere sowieso haesslich
	//this->deck = main->getDeck();

	//cardwidgets.clear();
	// werden neu angelegt von data() -> DecorationRole
	/*if(opened) {
		DeckIterator i(*deck);
		while(i.hasNext()) {
			CardWidget* w = new CardWidget; // wird nicht kompilieren => dann 0 setzen.
			w->setCard(i.next());
			w->setQuality(CardWidget::ThumbnailQuality);
			w->setGeometry( QRect(QPoint(), icon_size) );
			cardwidgets.append(w);
		}
	}*/
}


QVariant Model::data(const QModelIndex &index, int role) const {
	if(! index.isValid())
		return QVariant();

	if(role == Qt::DecorationRole) {
		// hm... will ne Deko kriegen und so
		int i = index.row();

		Q_ASSERT(navigator != 0);
		Q_ASSERT(navigator->main != 0);
		Q_ASSERT(navigator->main->deck != 0);

		DeckIndex card_index = navigator->main->deck->createIndex(i);
		if(!card_index.isValid()) {
			qDebug("Model: ungueltige Karte %d gefragt", i);
			return QVariant();
		}
		/*
		if(i >= cardwidgets.count()) {
			qDebug("Erstelle Kartenwidget %d", i);
			QPointer<CardWidget> w( new CardWidget );
			w->setCard( card_index.getCard() );
			w->setQuality( CardWidget::ThumbnailQuality );
			w->setGeometry( QRect(QPoint(), icon_size) );
			cardwidgets.insert(i, w);
		}*/
		card_widget->setCard( &navigator->main->deck->at(i) );

		// das hier kommt sonst sehr oft...
		//qDebug("Zeichne Karte %d von %d", i, deck->count());
		QPixmap ret = QPixmap::grabWidget( card_widget /* cardwidgets[i] */, QRect(QPoint(), icon_size));
		// sicherheitshalber
		card_widget->unsetCard();
		return ret;

	} else if(role == Qt::DisplayRole) {
		return tr("Card %1").arg(index.row());
	} else if(role == Qt::StatusTipRole) {
		return tr("You can <b>click and move</b> this card in the deck. Or <b>select multiple cards<b> with the rubberband.");
	}

	return QVariant();
}

Qt::ItemFlags Model::flags(const QModelIndex &index) const {
	if(index.isValid())
		return (Qt::ItemIsEnabled | Qt::ItemIsSelectable);
	else
		return 0;
}

int Model::rowCount(const QModelIndex &parent) const {
	if(parent.isValid())
		return 0;
	else {
		Q_ASSERT(navigator != 0);
		Q_ASSERT(navigator->main != 0);
		Q_ASSERT(navigator->main->deck != 0);
		return navigator->main->deck->count();
	}
}


void Model::contentsChanged(DeckIndex /*left*/, DeckIndex /*right*/) {
	// Ist halt ein casting DeckIndex -> int -> ModelIndex hier noetig,
	// daher kann man nicht einfach SIGNAL => SIGNAL patchen

	// mit dem folgenden sind Laengenaenderungen nicht abgedeckt:
	//emit dataChanged( index(left), index(right));
	reset();
}
