#ifndef M200_CLIENT_CLIENT_H
#define M200_CLIENT_CLIENT_H

#include <QThread>
#include <QMutex>

namespace QPunchCard {
namespace Device {
namespace DocumationM200 {
	class ClientThread;
};
};
};

#include "pc-uc-protocol.h"

#include "driver/documation-m200-client/controller.h"
#include "libs/qextserialport/qextserialport.h"

namespace QPunchCard {
namespace Device {
namespace DocumationM200 {

class ClientThread : public QThread {
	Q_OBJECT

	QextSerialPort port;
	bool abort;
	QMutex important_reading;

public:
	ClientThread(QObject* parent = 0);
	~ClientThread();

	void setAbort(bool value);

	void readLine();
	//void processResponse(QString code, QString comment);
	Card processCard();

signals:
	void recievedResponse(QString code, QString comment);

public slots:
	void fire_start();
	void fire_stop();
	void fire_ping();
	void fire_reset();


protected:
	void run();
};

}; // namespace DocumationM200
}; // namespace Driver
}; // namespace QPunchCard


#endif // M200_CLIENT_CLIENT_H
