#ifndef M200_CLIENT_CONTROLLER_H
#define M200_CLIENT_CONTROLLER_H

#include <QDockWidget>
#include <QString>
#include <QPointer>
#include <QList>
#include <QPushButton>

namespace QPunchCard {
namespace Device {
namespace DocumationM200 {
	class Controller; // GUI
	class Driver; // Backend
};
};
};

#include "driver/driver.h"
#include "app/mainwindow.h"
#include "client.h"

namespace QPunchCard {
namespace Device {
namespace DocumationM200 {

class Controller : public QWidget {
	Q_OBJECT

	QPointer<ClientThread> worker;
	QPointer<QTextEdit> log;

	QPushButton *start_button, *stop_button, *ping_button, *reset_button, *quit_button;

	QWidget* createButtonBar();

public:
	Controller(QWidget* parent = 0);

public slots:
	void logResponse(QString code, QString comment);
	void client_toggle_run();
};

}; // namespace DocumationM200
}; // namespace Driver
}; // namespace QPunchCard


#endif // M200_CLIENT_CONTROLLER_H
