#include <QDebug>

#include "format.h"

// formats
#include "qpunchcard/jones.h"

using namespace QPunchCard;

QList<QString> FileFormatFactory::availableFormats() {
	QList<QString> ret;
	ret << "Jones Emulated Card Deck File" << "Punch Card Markup Language File";
	return ret;
}

FileFormat FileFormatFactory::createFormat(const QString& name) {
	if(name == "Jones Emulated Card Deck File") {
		JonesFileFormat f;
		f.name = "Jones Emulated Card Deck File";
		return f;
	} if(name == "Punch Card Markup Language File") {
		PunchCardMarkupLanguageFormat f;
		f.name = "Punch Card Markup Language File";
		return f;
	} else {
		qDebug() << "FileFormatFactory: Invalid createFormat name: " << name;
		FileFormat f;
		return f;
	}
}

QString FileFormatFactory::autoDetectFormat(const QFile&) {
	// spaeter per magic bytes-Erkennung machen
	return QString("Jones Emulated Card Deck File");
}

