#ifndef TEXTEDITORDOCK_H
#define TEXTEDITORDOCK_H

#include <QPlainTextEdit>
#include <QDockWidget>
#include <QSharedPointer>

namespace QPunchCard {
namespace Text {
	class EditorDock;
};
};

#include "app/mainwindow.h"
#include "qpunchcard/card.h"
#include "text/codec.h"
#include "text/editor.h"

namespace QPunchCard {
namespace Text {

class EditorDock : public QDockWidget {
	Q_OBJECT

	App::MainWindow* main; // als links wegen Forward Declaration
	Text::Editor* editor;  // (unkomplette typen beim kompilieren)
	QWidget* code_bar;
	QWidget* color_bar;
	QString filename; // just for multiple exportText() calls
public:
	EditorDock(App::MainWindow* parent);

	const Codec* getCodec() const;
	QString getText() const;

private:
	void create_code_bar();
	void create_color_bar();

public slots:
	void setCard(DeckIndex i);
	void setCodec(QString by_name);
	void showTextConverterDialog();
	bool exportText();
	bool exportTextAs();

signals:
	void cardSelected(DeckIndex i);
};

}; // Namespace Text
}; // Namespace QPunchCard

#endif // TEXTEDITORDOCK_H
